<?php
/* Copyright start
  Copyright (C) 2008 - 2024 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 *  Migration to update values of historical_workflow_config
 */
final class Version20241018060185 extends AbstractMigration
{
    private const GET_PUBLIC_VALUES = "select publicvalues from cyops.system_settings where parent_uuid is null;";

    private string $historical_playbook_config = '{
        "completed_wf_transfer_interval" : 15,
        "failed_wf_transfer_interval" : 60
    }';

    public function getDescription() : string
    {
        return 'Default setting for historical workflow movement secondary';
    }


    public function up(Schema $schema) : void
    {

        $fetchResults = $this->connection->fetchAllAssociative(self::GET_PUBLIC_VALUES);
        if (count($fetchResults)) {
            $publicValue = json_decode($fetchResults[0]['publicvalues'], true);
            if (!array_key_exists('historical_workflow_config', $publicValue)) {
                $publicValue['historical_workflow_config'] = json_decode($this->historical_playbook_config, true);
                $updatedPublicValues = json_encode($publicValue);
                $this->addSql("update cyops.system_settings set publicvalues='".$updatedPublicValues."'");
            }
        }

    }

    public function down(Schema $schema) : void
    {
       // Not Needed
    }
}
